<?php
/*-
 * Copyright (c) 2008 Fredrik Lindberg - http://www.shapeshifter.se
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

require_once('db/iface.inc');

/*
 * Automatic SQL-backed preference system
 */
class Prefs {
    private $m_con;
    private $m_ident;
    private $m_data = array();
    private $m_dirty = false;
    private $m_fetched = false;

    public function __construct($connector, $ident) {
        $this->m_con = $connector;
        $this->m_ident = addslashes($ident);
    }

    public function __destruct() {
        $this->doflush();
    }

    private function __get($nm) {
        $this->dofetch();
        if (!isset($this->m_data[$nm]))
            return null;
        else
            return $this->m_data[$nm];
    }

    private function __set($nm, $val) {
        $this->dofetch();
        $this->m_data[$nm] = $val;
        $this->m_dirty = true;
    }

    public function Flush()
    {
        $this->doflush();
    }

    private function doflush() {
        if (!$this->m_dirty)
            return;

        $data = addslashes(serialize($this->m_data));
        $ident = $this->m_ident;
        $this->m_con->query("select count(*) from prefs where ident = \"$ident\"");
        $res = $this->m_con->fetchRow();
        if ($res[0] == 1) {
            $this->m_con->query("update prefs set data = \"$data\" where ident = \"$ident\"");
        }
        else {
            $this->m_con->query("insert into prefs(ident, data) values(\"$ident\", \"$data\")");
        }

        $this->m_dirty = false;
    }

    private function dofetch() {
        if ($this->m_fetched)
            return;
        $ident = $this->m_ident;
        $this->m_con->query("select data from prefs where ident = \"$ident\"");
        if ($this->m_con->getNumRows() == 1) {
            $res = $this->m_con->fetchRow();
            $this->m_data = unserialize(stripslashes($res[0]));
        }

        $this->m_fetched = true;
    }
}

?>