<?php
/*-
 * Copyright (c) 2008 Fredrik Lindberg - http://www.shapeshifter.se
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

require_once('jobs.inc');
require_once('prefs.inc');
require_once('static.inc');
require_once('db/db_mysql.inc');

if (!isset($argv)) {
    exit("Don't call me from a browser");
}

$pid = pcntl_fork();
if ($pid == -1) {
   die("could not fork");
} else if ($pid) {
    $con = new MySQLConnector(DB_HOST, DB_USER, DB_PWD, DB_NAME);
    $prefs = new Prefs($con, 'jobs');
    $prefs->worker_pid = $pid;
    $prefs->Flush();
    exit;
}

$con = new MySQLConnector(DB_HOST, DB_USER, DB_PWD, DB_NAME);
$jobs = new jobs($con);

$cwd = getcwd();
if ($cwd == false)
    exit("can't get working directory");

$pjid = -1;
for (;;) {
    $jid = $jobs->nextJob();
    if ($jid == -1 || $jid == $pjid)
        break;

    $cmd = escapeshellcmd(PHP_PATH . " $cwd/job_execute.php $jid");
    $desc = array();
    $proc = proc_open($cmd, $desc, $pipes);
    proc_close($proc);

    $pjid = $jid;
}

/* Tell the world that we aren't executing any more */
$prefs = new Prefs($con, 'jobs');
$prefs->worker_pid = null;
?>